/*
 *   $Id: grprefs.h,v 2.2 2000/09/27 01:02:44 ondra Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999,2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _GRPREFS_H_
#define _GRPREFS_H_

#include "segment.h"
#include "defuns.h"

#define MAX_GRFUNCS 6

typedef enum {
	graph_func,
	graph_polar,
	graph_param
}Tfunctype;

typedef struct {
	double xmin,ymin;
	double xmax,ymax;
	double fimin,fimax,fistep;
	double tmin,tmax,tstep;
	Tfunctype functype;
	char funcFunc[MAX_GRFUNCS][MAX_FUNCNAME+1];
	char funcPol[MAX_GRFUNCS][MAX_FUNCNAME+1];
	char funcPar[MAX_GRFUNCS][2][MAX_FUNCNAME+1];
}TgrPrefs;

Boolean GraphPrefsHandleEvent(EventPtr event) IFACE;
void grpref_init(void) IFACE;
void grpref_close(void) IFACE;

extern TgrPrefs graphPrefs;
#endif
