/*
 *   $Id: defuns.h,v 2.19 2000/09/27 00:01:58 ondra Exp $
 *
 *   Scientific Calculator for Palm's and PilmPilot's.
 *   Copyright (C) 1999 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _DEFUNS_H_
#define _DEFUNS_H_

#include "segment.h"
#include "konvert.h"

#define MAX_FP_NUMBER 30

/* Application specific things */
#define APP_ID  'OpCl'
#define LIB_ID  'OpCl'
#define DBNAME  "CalcDB-OpCl"
#define HISTORYDBNAME "CalcDB-H-OpCl"
#define DBTYPE   'Data'
#define CARDNO  0

#define DBVERSION 2

#define PREF_DEFAULT  0
#define PREF_RESULT   1
#define PREF_GRAPH    2
#define PREF_VERSION        16
#define PREF_RES_VERSION    1
#define PREF_GRAPH_VERSION  1

#define MAX_INPUT_LENGTH  100
#define MAX_HISTORY  15
#define MAX_RESULT 17

/* konvert.c constants */
#define MAX_RPNSIZE 105
#define MAX_OSTACK 45

#define NaN ((double)(3-3)/(3-3))

void DoubleToAscii(double value,char *strP) MLIB;
void GetDisplayMode(Int16 *mode,Int16 *frac,Int16 *floatmode,Boolean *reducePrecision) MLIB;
void SetDisplayMode(Int16 mode,Int16 frac,Int16 floatmode,Boolean reducePrecision) MLIB;
void SetFlPoint(char flpoint) MLIB;
char * guess(Trpn item) MLIB;

#endif
