/*   
 *   $Id: funcs.h,v 2.12 2000/09/28 23:12:32 ondra Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999,2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _FUNCS_H_
#define _FUNCS_H_

/* Maximal depth in user functions */
#define MAX_RECURS 10
/* When the 'real' argument is zero */
#define IS_ZERO(x)      (fabs(x)<1E-6)

#define FUNC_PLUS      0
#define FUNC_MINUS     1
#define FUNC_MULTIPLY  2
#define FUNC_DIVIDE    3
#define FUNC_POWER     4
#define FUNC_EQUAL     5
#define FUNC_NEGATE    6
#define FUNC_DISCARD   7
#define FUNC_AND       8
#define FUNC_OR        9
#define FUNC_SHL       10
#define FUNC_SHR       11
#define FUNC_EMPTY     12
#define FUNC_X         13
#define FUNC_MOD       14

#define FUNC_DEGREE     1
#define FUNC_RADIAN     2
#define FUNC_GONIO      3
#define FUNC_TOCIS      4

CError convert_real_to_string(Int16 funcnum,CodeStack *stack);
CError convert_cplx_to_string(Int16 funcnum,CodeStack *stack);
CError define_func(Int16 funcnum,CodeStack *stack);
CError change_param_name(Int16 funcnum,CodeStack *stack);
CError unset_variable(Int16 funcnum,CodeStack *stack);
CError discard_arg(Int16 funcnum,CodeStack *stack);
CError empty_arg(Int16 funcnum,CodeStack *stack);
CError rpn_eval_variable(Trpn *dest,Trpn source);
CError set_ans_var(Trpn ans);
CError eval_x(Int16 funcnum,CodeStack *stack);
CError text_function(char *name,CodeStack *stack);
void set_func_argument(Trpn *arg);
void decr_func_argument(void);
Boolean varfunc_name_ok(char *name,rpntype type);
#endif
