/*   
 *   $Id: mathem.h,v 2.13 2000/09/24 14:59:19 ondra Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999,2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _INTOPS_H
#define _INTOPS_H

#include "segment.h"

/* These are helper constants to allow one function serve
 * more types of operation. They needn't be unique, but must
 * be unique inside the function, that operates this type of
 * operation.
 */

#define MATH_SIN   0
#define MATH_COS   1
#define MATH_TAN   2
#define MATH_SINH  3
#define MATH_COSH  4
#define MATH_TANH  5
/* */
#define MATH_ASIN  6
#define MATH_ACOS  7
#define MATH_ATAN  8
#define MATH_ASINH 9
#define MATH_ACOSH 10
#define MATH_ATANH 11
/* */
#define MATH_EXP   12
#define MATH_LN    13
#define MATH_LOG   14
#define MATH_SQRT  15
#define MATH_CBRT  16
#define MATH_ABS   17
#define MATH_LOG2  18
#define MATH_TRUNC 19
#define MATH_ROUND 20
#define MATH_FPART 21
#define MATH_REAL  22
/* */
#define MATH_FACT  19
/* Combinatorics */
#define MATH_PERM  23
#define MATH_COMB  24
/* */
#define MATH_FZERO 25
/* */
#define MATH_RTOPR  26
#define MATH_RTOPD  27
#define MATH_PTORX  28
#define MATH_PTORY  29

/* Mathematical declarations */
#ifndef M_PIl
#define M_PIl 3.14159265358979323846
#endif
#define M_PI_SQRT 1.77245385091
/* Precision for solving functions */
#define F_IS_ZERO(x)   (fabs(x)<1E-10)

CError math_oper(Int16 funcnum,CodeStack *stack) MLIB;
CError math_neg(Int16 funcnum,CodeStack *stack) MLIB;
CError math_trigo(Int16 funcnum,CodeStack *stack) MLIB;
CError math_arctrigo(Int16 funcnum,CodeStack *stack) MLIB;
CError math_math(Int16 funcnum,CodeStack *stack) MLIB;
CError math_bin(Int16 funcnum,CodeStack *stack) MLIB; 
CError math_fact(Int16 funcnum,CodeStack *stack) MLIB;
CError math_int(Int16 funcnum,CodeStack *stack) MLIB;
CError math_comb(Int16 funcnum,CodeStack *stack) MLIB;
CError math_fsolve(Int16 funcnum,CodeStack *stack) MLIB;
CError math_convcoord(Int16 funcnum,CodeStack *stack) MLIB;
#endif
