/*   
 *   $Id: fl_num.c,v 2.3 2000/09/16 23:41:25 ondra Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#include <PalmOS.h>

#include "segment.h"

#define isdigit(x) (x>='0' && x<='9')

/* Is a number, equal to /[0-9]+/ */
static Int16 is_ccbz(char *input,double *cislo) MLIB;
static Int16
is_ccbz(char *input,double *cislo)
{
	Int16 i,j;
		
	for (i=0;isdigit(input[i]);i++)
	  ;
	if (cislo) {
		*cislo=0.0;
		for (j=0;j<i;j++) {
			*cislo*=10.0;
			*cislo+=input[j]-'0';
		}
		j=*cislo;
	}
	return i;
}

static Int16 has_expon(char *input,double *cislo) MLIB;
static Int16
has_expon(char *input,double *cislo)
{
	char *tmp=input;
	Int16 delka=0;
	Int16 i;
	
	if (*tmp=='E') {
		Int16 negate=0;
		double expon;
		
		tmp++;delka++;
		if (*tmp=='-') {
			negate=1;
			tmp++;delka++;
		}
		else if (*tmp=='+') {
			tmp++;delka++;
		}
	        if (!(i=is_ccbz(tmp,&expon)))
		  return 0;
		delka+=i;
/* Prevent excessive waiting */
		if (expon>350.0)
		  return 0;
		
		*cislo=1.0;
		if (!negate)
		  for (i=0;i<expon;i++)
		    *cislo*=10.0;
		else
		  for (i=0;i<expon;i++)
		    *cislo/=10.0;
	}
	return delka;
}

/* Is floating number, return number of characters describing
 * the number */
Int16 fl_num(char *input,double *cislo) MLIB;
Int16
fl_num(char *input,double *cislo)
{	
	char *tmp=input;
	double cele;
	double expon;
	Int16 i=0,j;
	double dfl;
	Int16 delka=0;
		
	if ((i=is_ccbz(tmp,&cele))) {
		tmp+=i;
		delka+=i;
	}
	else
	  cele=0;       
	      
	if (*tmp!='.' && *tmp!=',' && delka==0)
	  return 0;
	else if (*tmp!='.' && *tmp!=',' && delka>0) {
		*cislo=cele;
		if ((i=has_expon(tmp,&expon))) {
			*cislo*=expon;
			delka+=i;tmp+=i;	
		}
		return delka;
	}
	tmp++;delka++;
	
	if (!(i=is_ccbz(tmp,NULL))) {
		if (delka)
		  *cislo=cele;
		return delka;
	}
	delka+=i;

	dfl=.1;
	for (j=0;j<i;j++) {
		cele+=((double)(tmp[j]-'0'))*dfl;
		dfl/=10;
	}
	*cislo=cele;
	tmp+=i;
	
	if ((i=has_expon(tmp,&expon))) {
		*cislo*=expon;
		delka+=i;tmp+=i;	
	}
	
	return delka;
}
