 /*   
 * $Id: prefs.h,v 2.3 2000/09/27 00:01:54 ondra Exp $
 * 
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999,2000 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _PREFS_H_
#define _PREFS_H_

#include "segment.h"
#include "konvert.h"
#include "defuns.h"

typedef struct {
	char input[MAX_INPUT_LENGTH+1];
	UInt16 form;     /* last form */
	UInt16 insertPos;     /* last insert position */
	UInt16 selPosStart, selPosEnd;
	Boolean finBegin;  /* Begin/end selector in financial form */
	
	Int8 defFrac;   /* default precision */
	Boolean reducePrecision;
	Boolean stripZeros; /* false=strip, true=fix mode */
	Boolean matchParenth; /* Add ')' to functions ending with '(' */
	Boolean forceComplex;
	Int8 sciMode;   /* default mode for displaying numbers*/
	char history[MAX_HISTORY][MAX_INPUT_LENGTH+1];
	Tint_mode int_mode;
	Ttrigo_mode trigo_mode;
}tPrefs;

void prefs_read_preferences() IFACE;
void  prefs_save_preferences() IFACE;
Boolean PreferencesHandleEvent(EventPtr event) IFACE;

extern tPrefs calcPrefs;
#endif
