/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// artdb.h
//
// article database headers for use with yanoff
// Matthias Jordan, 4-1999
//
//


#ifndef ARTDB_H
#define ARTDB_H


#include "yanoff.h"

#define ART_SIZE_START 60000


//extern char articledb_name[];




//
// The article
//

typedef struct articledb_item
{
    UInt flags;            // Valid values: yfArticleFlagXXX (see below)
    ULong rcvdate;
    UInt xpostings;        // has the number of incarnations on the device (NOT the CrossPostings)
    char *from,
         *date,
         *subject,
         *newsgroups,
         *msgid,
         *body;
} articledb_item;



#define yfArticleFlagMarked 1
#define yfArticleFlagRead 2
#define yfArticleFlagKeep 4

DmOpenRef ArtOpenArticles(void);
void ArtCloseArticles(void);



// Append article to global article database
int ArtAppendArticleHeader(struct articledb_item *art, UInt *pos);
    
int ArtAppendArticleBody(int pos, char *buf);
    

// Read article from global article database
int ArtReadArticle(int pos, struct articledb_item *art);

UInt ArtChangeArticleXP(ULong uid, int dcount);

// Reduce xposting counter and delete article from db if xpostings == 0
int ArtDeleteArticle(ULong uid);

// Get article with unique ID uid in open newsgroup
//int ArtSeekArticle(ULong uid, struct articledb_item *art);
int ArtSeekArticle(ULong uid, UInt *pos);

int ArtSetArticleFlag(ULong uid, int flag, int value);

VoidHand ArtResizeArticle(UInt pos, Word len);

ULong ArtGetArticleUID(UInt pos);
UInt ArtArticlesCount(void);
void ArtFreeArticleData(struct articledb_item *a);
void ArtPurgeArticles(ULong deltadays);


#endif

