/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// frmsubs.c
//
// Handles the Subscription form
// Matthias Jordan, 4-1999
//
//


#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "yanoff.h"
#include "general.h"
#include "subscrdb.h"
#include "ngroup.h"



//
//
// Subscription routines
//
//



static int Subscribe(void)
{
	int res;
    char *ng;

    ng = GetFormParameter("Newsgroup", fldSubsName);
    if (ng == NULL)
    {
        return 0;
    }
    res = SubAddSubscription(ng);
	if (!res)
    {
        FrmUpdateForm(frmNewsgroups, 0);
    }
    else if (res == 2)
    {
        FrmCustomAlert(alertID_dum, "Newsgroup", "already", "subscribed");
    }
    else
    {
    	FrmCustomAlert(alertID_dum, "General exception (TM)", " ", " ");
    }
    return 1;
} /* Subscribe */






Boolean SubscribeHandler(EventPtr event)
{
    int handled = 0;
    FormPtr frm;

    switch (event->eType)
    {
        case frmOpenEvent:
        {
        	frm = FrmGetActiveForm();
            RefreshForm();
			FrmSetFocus(frm, FrmGetObjectIndex(frm, fldSubsName));
            handled = 1;
            break;
        }

		case ctlSelectEvent:
		{
			if (event->data.ctlSelect.controlID == btnSubsOk)
			{
				if (Subscribe())
				{
					NPExitForm();
				}
				handled = 1;
			}
			else if (event->data.ctlSelect.controlID == btnSubsCancel)
			{
				NPExitForm();
				handled = 1;
			}
			
		}

        default:
    }
    return handled;
} /* SubscribeHandler */






void Unsubscribe(char *ng)
{
	UInt max, 
		i;
//		pos;
	char *ng2del;
	VoidHand h;
	

    if (ng == NULL)
    {
        return;
    }
    
	// Memorize newsgroup name
	h = MemHandleNew(StrLen(ng) + 1);
	if (h == 0)
	{
		return;
	}
	ng2del = MemHandleLock(h);
	StrCopy(ng2del, ng);
	
	// Delete all articles in group
	max = NGArticlesCount();
	for (i = 0; (i < max); i++)
	{
		NGDeleteArticle(0);
	}
	NGCloseNewsgroup();
	
    if (!SubDeleteSubscription(ng2del))
    {
        FrmCustomAlert(alertID_dum, "Successfully unsubscribed", " ", " ");
    }
    MemHandleUnlock(h);
    MemHandleFree(h);
} /* Unsubscribe */

