/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// menu.c
//
// handle the main menu of yanoff
// Matthias Jordan, 4-1999
//
//


#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>


#include "yanoff.h"
#include "general.h"
#include "frmsubs.h"
#include "network.h"
#include "ngroup.h"


int HandleMainMenu(EventPtr event)
{
	int handled = 0;
	char *ng;

	if (event->data.menu.itemID == mConn)
    {
		if (!NPInitNetwork() && !NPConnect())
		{
			FrmCustomAlert(alertID_dum, "Server connected.", "Working online.", " ");
			NPWorkOnline(1); // set internal flag
		}
        handled = 1;
    }
    else if (event->data.menu.itemID == mDisc)
    {
		NPCloseNetwork(1);
		FrmCustomAlert(altInfo, "Network closed", " ", " ");
        handled = 1;
    }
    else if (event->data.menu.itemID == mAbout)
    {
		NPGotoForm(frmAbout);
        handled = 1;
    }
    else if (event->data.menu.itemID == mGetArticles)
    {
		NPInvokePoll(pollArticles, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mGetBodies)
    {
		NPInvokePoll(pollBodies, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mGetHeaders)
    {
		NPInvokePoll(pollHeaders, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mPrefs)
    {
        NPGotoForm(frmPrefs);
        handled = 1;
    }
    else if (event->data.menu.itemID == mPurge)
    {
		if (!FrmCustomAlert(altDeleteConf, "old", " ", " "))
		{
			NGPurge(purgeArticles);
			// NGPurge also sends an update event to artlist
		}
        handled = 1;
    }
    else if (event->data.menu.itemID == mDeleteSel)
    {
		if (!FrmCustomAlert(altDeleteConf, "selected", " ", " "))
		{
			NGDeleteSelectedRead(0);
			FrmUpdateForm(frmArtList, 1);
		}
        handled = 1;
    }
    else if (event->data.menu.itemID == mDeleteRead)
    {
		if (!FrmCustomAlert(altDeleteConf, "read", " ", " "))
		{
			NGDeleteSelectedRead(1);
			FrmUpdateForm(frmArtList, 1);
		}
        handled = 1;
    }
    else if (event->data.menu.itemID == mKeepSel)
    {
		NGKeepSelected(1);
		FrmUpdateForm(frmArtList, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mUnkeepSel)
    {
		NGKeepSelected(0);
		FrmUpdateForm(frmArtList, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mSelAll)
    {
    	NGMarkArticles(1);
    	FrmUpdateForm(frmArtList, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mSelNone)
    {
    	NGMarkArticles(0);
    	FrmUpdateForm(frmArtList, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mSelInv)
    {
    	NGMarkArticles(-1);
    	FrmUpdateForm(frmArtList, 0);
        handled = 1;
    }
    else if (event->data.menu.itemID == mSubs)
    {
        NPGotoForm(frmSubscribe);
        handled = 1;
    }
    else if (event->data.menu.itemID == mUnsubs)
    {
    	ng = NGActiveNewsgroup();
    	if (ng != NULL)
    	{
			if (FrmCustomAlert(altUnsubs, ng, " ", " ") == 0)
			{
				Unsubscribe(ng);
				FrmUpdateForm(frmNewsgroups, 0);
				NPExitForm();
			}
		}
		else
		{
			FrmCustomAlert(altInfo, "You have to be inside a Newsgroup"
				" to unsubscribe it.", " ", " ");
		}
        handled = 1;
    }
    return handled;
} /* HandleMainMenu */

