/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// prefs.c
//
// handle the prefs form of yanoff
// Matthias Jordan, 4-1999
//
//


#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/DataMgr.h>
#include <System/NetMgr.h>
#include <System/DateTime.h>


#include "yanoff.h"
#include "general.h"

#include "prefs.h"

struct prefs yprefs;


void PrSavePrefs(void)
{
	PrefSetAppPreferences(TYPE, 1, VERSION, yprefs.server, StrLen(yprefs.server) + 1, 1);
	PrefSetAppPreferences(TYPE, 2, VERSION, &yprefs.port, 2, 1);
	PrefSetAppPreferences(TYPE, 3, VERSION, &yprefs.idpurgedays, 2, 1);
	PrefSetAppPreferences(TYPE, 4, VERSION, &yprefs.artpurgedays, 2, 1);
	PrefSetAppPreferences(TYPE, 5, VERSION, &yprefs.samplearts, 2, 1);
	PrefSetAppPreferences(TYPE, 6, VERSION, &yprefs.timeoutsecs, 2, 1);
	PrefSetAppPreferences(TYPE, 7, VERSION, &yprefs.artmaxkb, 2, 1);
} /* PrSavePrefs */



void PrGetPrefs(void)
{
	Word size;
	
	size = 40;
	if (PrefGetAppPreferences(TYPE, 1, yprefs.server, &size, 1) == noPreferenceFound)
	{
		StrCopy(yprefs.server, "news.massena.com");
	}
	yprefs.server[39] = 0;
	size = 2;
	if (PrefGetAppPreferences(TYPE, 2, &yprefs.port, &size, 1) == noPreferenceFound)
	{
		yprefs.port = 119;
	}
	size = 2;
	if (PrefGetAppPreferences(TYPE, 3, &yprefs.idpurgedays, &size, 1) == noPreferenceFound)
	{
		yprefs.idpurgedays = 5;
	}
	size = 2;
	if (PrefGetAppPreferences(TYPE, 4, &yprefs.artpurgedays, &size, 1) == noPreferenceFound)
	{
		yprefs.artpurgedays = 2;
	}
	size = 2;
	if (PrefGetAppPreferences(TYPE, 5, &yprefs.samplearts, &size, 1) == noPreferenceFound)
	{
		yprefs.samplearts = 20;
	}
	size = 2;
	if (PrefGetAppPreferences(TYPE, 6, &yprefs.timeoutsecs, &size, 1) == noPreferenceFound)
	{
		yprefs.timeoutsecs = 20;
	}
	size = 2;
	if (PrefGetAppPreferences(TYPE, 7, &yprefs.artmaxkb, &size, 1) == noPreferenceFound)
	{
		yprefs.artmaxkb = 10;
	}
} /* PrGetPrefs */



