/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// subscrdb.h
//
// newsgroup subscription management headers for use with yanoff
// Matthias Jordan, 4-1999
//
//


#ifndef SUBSCRDB_H
#define SUBSCRDB_H


//
// All articles are stored in a huge database to implement crossposting.
// Every newsgroup gets its own ref database that only contains the ids
// of its articles from the article database.
// A third database is used to store the subscriptions, i.e.
// what newsgroups do we have, what is their last article and in
// which database are the article ids stored.
//


typedef struct subscriptiondb_item
{
    char dbid[6];
    ULong last;
    char *newsgroup;
} subscriptiondb_item_t;



//
// An array of this type forms the database of a newsgroup.
// the article_id refers to the member "id" in struct articledb_item
//


//typedef DWord article_id;


char *SubNGDatabaseName(char *ng, char *buf);


DmOpenRef SubOpenSubscriptions(void);
void SubCloseSubscription(void);

int SubAddSubscription(char *newsgroup);
int SubReadSubscription(char *newsgroup, char *dbid, ULong *last);
int SubUpdateSubscription(char *newsgroup, ULong last);
int SubDeleteSubscription(char *newsgroup);

int SubSeekSubscription2(UInt pos, char **ngname);

int SubSubscriptionsCount(void);



#endif

