/**************************************************************************

	Yanoff - the free UseNet news reader for the Palm Computing Platform
    Copyright (C) 1999 Matthias Jordan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Reach the author via 
	email: mjordan@sensenet.wirepool.free.de

**************************************************************************/
//
//
// yanoff.c
//
// yanoff dummy
// Matthias Jordan, 4-1999
//
//


#pragma pack(2)

#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "yanoff.h"
#include "general.h"
#include "network.h"
#include "artdb.h"
#include "ngroup.h"
#include "subscrdb.h"
#include "prefs.h"
#include "msgiddb.h"

#include "frmsubs.h"
#include "frmprefs.h"
#include "frmnglist.h"
#include "frmartlist.h"
#include "frmart.h"

extern char *buf;
extern Word buf_len;





static Boolean AboutHandler(EventPtr event)
{
    int handled = 0;

    switch (event->eType)
    {
        case frmOpenEvent:
        {
            RefreshForm();
            handled = 1;
            break;
        }

		case ctlSelectEvent:
		{
			if (event->data.ctlSelect.controlID == btnAboutOK)
			{
				NPExitForm();
			}
			handled = 1;
			break;
		}

        default:
    }
    return handled;
} /* AboutHandler */










static Boolean AppHandleEvent(EventPtr event)
{
  int formID;
  FormPtr form;

    if (event->eType == frmLoadEvent)
    {
      formID = event->data.frmLoad.formID;
      form = FrmInitForm(formID);
      FrmSetActiveForm(form);
      switch (formID) 
      {
        case frmNewsgroups:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandleNewsgroups);
        break;

        case frmArtList:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandleArtList);
        break;

        case frmArticle:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandleArticle);
        break;

        case frmPoll:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandlePoll);
        break;

        case frmAbout:
        FrmSetEventHandler(form, (FormEventHandlerPtr) AboutHandler);
        break;

        case frmSubscribe:
        FrmSetEventHandler(form, (FormEventHandlerPtr) SubscribeHandler);
        break;

        case frmPrefs:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandlePrefs);
        break;

        case frmPurge:
        FrmSetEventHandler(form, (FormEventHandlerPtr) HandlePurge);
        break;
      }
      return true;
    } 
    return false;
} /* AppHandleEvent */











static void EventLoop(void)
{
  short err;
  EventType event;

  do
  {

    EvtGetEvent(&event, -1);

    if (!SysHandleEvent(&event))
    {
	    if (!MenuHandleEvent((void *)0, &event, &err))
		{
			if (!AppHandleEvent(&event))
			{
				FrmDispatchEvent(&event);
			}
		}
	}			
  }
  while(event.eType != appStopEvent);
} /* EventLoop */


static void StartApp(void)
{
	PrGetPrefs();
	NPInitFormStack(frmNewsgroups);
	SubOpenSubscriptions();
	ArtOpenArticles();
} /* StartApp */



static void StopApp(void)
{
	ArtCloseArticles();
	NGCloseNewsgroup();
	SubCloseSubscription();
	NPCloseNetwork(0);
    FrmCloseAllForms();
} /* StopApp */



DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
//  int error;

  if (cmd == sysAppLaunchCmdNormalLaunch)
  {
    StartApp();
    EventLoop();    // Event loop
    StopApp();
  }
  return 0;
} /* PilotMain */

